;========================================================================
;                                                                       =
;                         LICALC2 & ROOT2sp v2.4                        =
;                                                                       =
; BASIC Version Written By:  Steven Z       siyu12345@yahoo.com         =
;   ASM Version Written By:  Morgan Davies  morgan@ticalc.org           =
;                                           Morgazum85@Juno.com         =
;                                                                       =
;              Upload Date:  January 21, 2004                           =
;                     Size:  1693 Bytes (LICALC2)                       =
;                             897 Bytes (ROOT2sp)                       =
;                            2706 Bytes (Total)                         =
;               Basic Size:  2590 Bytes (Total)                         =
;                                                                       =
; Information about the source:                                         =
;                                                                       =
;   These two programs are a directo port from the 86 Basic Version,    =
; which is also listed in the ticalc.org archives. The sole purpose of  =
; this code was to simulate the function and all the options available  =
; in the Basic version while keeping the appearance of a Basic file.    =
; The source itself is very messy. I could not compress LICALC2 with    =
; Lite 86 II ecause it calls ROOT2sp from within the code. However      =
; ROOT2sp was compressed and saved around 200 or more bytes on that     =
; file. If anyone has questions about 86 assembly math please feel free =
; to contact me (Morgan) at either of the above e-mail addresses.       =
;                                                                       =
; Special Thanks:                                                       =
;                                                                       =
;   Kirk Meyer   (kirkmeyer@bigfoot.com)                                =
;    For making Lite 86 II, and therefor making 86 ASM programs smaller =
;   Steven Z     (siyu12345@yahoo.com)                                  =
;    For teaching me how to reduce roots, for answereing general        =
;    questions about the program, beta testing, and letting me convert  =
;    his program in the first place!                                    =
;                                                                       =
;========================================================================


#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

;.plugin lite86;                     ;the ultimate compression routine

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String0                     ;print string

Start:
    call _flushallmenus             ;clears all key codes
    call _runindicoff               ;turn off run indicator
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    call Check_Variable             ;goes to Check_Variable
    ld hl,(256*0)+0                 ;loads coordinates into hl, row 1, col 1
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String0                   ;loads hl with string
    call _puts                      ;print string
    ld hl,(256*0)+1                 ;loads coordinates into hl, row 2, col 1
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String1                   ;loads hl with string
    call _puts                      ;print string
    ld hl,E1                        ;string to print
    call Input                      ;goes to Input
    call _op1toop3
    ld hl,x1                        ;variable name to store op2 to
    call Create_Variable            ;creates real variable hl with op2
    ld hl,E2                        ;string to print
    call Input                      ;goes to Input
    call _op1toop3
    ld hl,y1                        ;variable name to store op2 to
    call Create_Variable            ;creates real variable hl with op2
    ld hl,E3                        ;string to print
    call Input                      ;goes to Input
    call _op1toop3
    ld hl,x2                        ;variable name to store op2 to
    call Create_Variable            ;creates real variable hl with op2
    ld hl,E4                        ;string to print
    call Input                      ;goes to Input
    call _op1toop3
    ld hl,y2                        ;variable name to store op2 to
    call Create_Variable            ;creates real variable hl with op2
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    call SubText1
    call _FPSQUARE
    call _op1toop4
    call SubText2
    call _FPSQUARE
    call _op4toop2
    rst 30h
    call _op1toop3
    ld hl,a2
    call Create_Variable            ;creates real variable hl with op2
    ld a,2
    call _setXXop2
    call _op2toop3
    ld hl,a1
    call Create_Variable            ;creates real variable hl with op2
    ld a,1
    call _setXXop2
    call _op2toop3
    ld hl,a5
    call Create_Variable
    call SubText3
    call _clrScrn
    ld hl,a4
    call Recall_Variable
    ld hl,(256*0)+0                 ;loads coordinates into hl, row 1, col 1
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,E5                        ;loads hl with string
    call _puts
    call DispAnswer
    ld hl,a1
    call Recall_Variable
    rst 08h
    ld hl,a4
    call Recall_Variable
    call _YTOX
    call _op1toop6
    ld hl,a2
    call Recall_Variable
    call _op6toop2
    call _FPDIV
    ld hl,String11
    call Text1
    ld hl,a2
    call Recall_Variable
    call _SQROOT
    ld hl,E6
    call Text1
    call SubText6
    ld a,2
    call _setXXop2
    call _FPDIV
    ld hl,E7
    call SubText5
    ld a,2
    call _setXXop2
    call _FPDIV
    ld hl,E8
    call Text1
    call SubText1
    call _op1toop4
    call SubText2
    call _op4toop2
    call _FPDIV
    ld hl,E9
    call _puts                      ;prints string
    call DispAnswer                 ;goes to DispAnswer
    ld hl,String3
    call _puts
    rst 08h
    ld hl,x1
    call Recall_Variable
    call SubText7
    call DispAnswer                 ;goes to DispAnswer
    ld hl,String4                   ;string to print
    ld bc,256*58+5                  ;column 6, row 59
    ld (_penCol),bc                 ;loads c into _penCol
                                    ;  and b into _penRow
    call _vputs                     ;print it and return
    ld hl,String5                   ;string to print
    ld bc,256*58+53                 ;column 54, row 59
    call SubText4b
GetKey1:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compares a with Exit key
    jp z,Exit                       ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a with Alpha key
    call z,CalcOff                  ;if Alpha jump to calcOff
    cp K_F1                         ;compares a with F1 key
    jp z,Start                      ;if F1 jump to Start
    cp K_F3                         ;compares a with F3 key
    jr z,Distance                   ;if F2 jump to Distance
    cp K_F5                         ;compares a with F5 key
    jp z,Exit                       ;if F3 jump to Exit
    jr GetKey1                      ;jumps to GetKey1

Distance:
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    call SubText3
    ld hl,(256*0)+5                 ;loads coordinates into hl, row 1, col 1
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String11
    call _puts
    ld hl,a4
    call Recall_Variable
    call _FPSQUARE
    call DispAnswer
    ld hl,a4
    call Recall_Variable
    call _FPSQUARE
    rst 08h
    ld hl,a2
    call Recall_Variable
    call _FPDIV
    ld hl,String11                  ;loads hl with string
    call Text1
    ld hl,(256*0)+0                 ;loads coordinates into hl, row 1, col 1
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String7                   ;loads hl with string
    call _puts                      ;print string
    call SubText1
    ld hl,String8
    call Text1
    call _FPSQUARE
    call _stoX
    call SubText2
    ld hl,String9
    call Text1
    call _FPSQUARE
    call _stoY
    ld hl,String10
    call _puts
    call DispAnswer
    ld hl,String12
    call _puts
    call _rclX
    call DispAnswer
    call _newline
    rst 08h
    call _rclY
    rst 30h
    ld hl,String11
    call Text1
    call _newline
    ld hl,a2
    call Recall_Variable
    call _SQROOT
    ld hl,String13
    call SubText4a
GetKey2:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compares a with Exit key
    jp z,Exit                       ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a with Alpha key
    call z,CalcOff                  ;if Alpha jump to calcOff
    cp K_F1                         ;compares a with F1 key
    jr z,MidPoint                   ;if F1 jump to Start
    cp K_F5                         ;compares a with F5 key
    jp z,Exit                       ;if F3 jump to Exit
    jr GetKey2                      ;jumps to GetKey2

MidPoint:
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    ld hl,(256*0)+0                 ;loads coordinates into hl, row 1, col 1
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String16                  ;loads hl with string
    call _puts                      ;print string
    call _newline
    call _puts                      ;print string
    call _newline
    call _puts                      ;print string
    call _newline
    call SubText6
    call _stoX
    ld hl,String19
    call SubText5
    ld hl,String20
    call Text1
    ld a,2
    call _setXXop2
    call _FPDIV
    call _stoY
    call _rclX
    ld a,2
    call _setXXop2
    call _FPDIV
    ld hl,String21
    call Text1
    call _rclY
    ld hl,String22
    call SubText4a
GetKey3:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compares a with Exit key
    jp z,Exit                       ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a with Alpha key
    call z,CalcOff                  ;if Alpha jump to calcOff
    cp K_F1                         ;compares a with F1 key
    jr z,Eqn                        ;if F1 jump to Start
    cp K_F5                         ;compares a with F5 key
    jp z,Exit                       ;if F3 jump to Exit
    jr GetKey3                      ;jumps to GetKey3

Eqn:
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    ld hl,(256*0)+0                 ;loads coordinates into hl, row 1, col 1
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String23                  ;loads hl with string
    call _puts                      ;print string
    call _newline
    call _puts                      ;print string
    call _newline
    call SubText2
    call _stoX
    ld hl,String25
    call _puts                      ;prints string
    call DispAnswer                 ;goes to DispAnswer
    ld hl,String26
    call _puts
    call SubText1
    call DispAnswer
    call _newline
    rst 08h
    call _rclX
    call _FPDIV
    ld hl,String25
    call Text1
    ld hl,String27
    call _puts
    call _newline
    ld hl,y1
    call Recall_Variable
    ld hl,String28
    call _puts
    call DispAnswer
    ld hl,String29
    call _puts
    call _rclX
    call _FPDIV
    call _stoX
    call DispAnswer
    ld hl,String30
    call _puts
    ld hl,x1
    call Recall_Variable
    call DispAnswer
    call _newline
    rst 08h
    call _rclX
    call SubText7
    ld hl,String28
    call Text1
    ld hl,String4                   ;string to print
    ld bc,256*58+5                  ;column 6, row 59
    call SubText4b
GetKey4:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compares a with Exit key
    jp z,Exit                       ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a with Alpha key
    call z,CalcOff                  ;if Alpha jump to calcOff
    cp K_F1                         ;compares a with F1 key
    jp z,Start                      ;if F1 jump to Start
    cp K_F5                         ;compares a with F5 key
    jp z,Exit                       ;if F3 jump to Exit
    jr GetKey4                      ;jumps to GetKey4

SubText1:
    ld hl,x2
    call Recall_Variable
    rst 08h
    ld hl,x1
    call Recall_Variable
    call _FPSUB
    ret

SubText2:
    ld hl,y2
    call Recall_Variable
    rst 08h
    ld hl,y1
    call Recall_Variable
    call _FPSUB
    ret

SubText3:
    ld hl,ROOT2sp-1                 ;loads hl with prgm name to execute
    rst 20h                         ;op1 = name of 2nd asm prog to call
    rst 10h                         ;call _findsym, see if variable exists
    jp c,Text2                      ;if not jump to Text2
    call _exec_assembly             ;execute asm prgm in op1
    ret

SubText4a:
    call Text1
    ld hl,String14                  ;string to print
    ld bc,256*58+6                  ;column 7, row 59
SubText4b:
    ld (_penCol),bc                 ;loads c into _penCol
                                    ;  and b into _penRow
    call _vputs                     ;print it and return
    ld hl,String15                  ;string to print
    ld bc,256*58+107                ;column 108, row 59
    ld (_penCol),bc                 ;loads c into _penCol
                                    ;  and b into _penRow
    call _vputs                     ;print it and return
    call MenuRoutine1
    ret

SubText5:
    call Text1
    ld hl,y2
    call Recall_Variable
    rst 08h
    ld hl,y1
    call Recall_Variable
    rst 30h
    ret

SubText6:
    ld hl,x2
    call Recall_Variable
    rst 08h
    ld hl,x1
    call Recall_Variable
    rst 30h
    ret

SubText7:
    rst 28h
    rst 08h
    ld hl,y1
    call Recall_Variable
    call _FPSUB
    ret

Check_Variable:
    ld hl,x1
    call Delete_Variable
    ld hl,x2
    call Delete_Variable
    ld hl,y1
    call Delete_Variable
    ld hl,y2
    call Delete_Variable
    ld hl,a1
    call Delete_Variable
    ld hl,a2
    call Delete_Variable
    ld hl,a3
    call Delete_Variable
    ld hl,a4
    call Delete_Variable
    ld hl,a5
    call Delete_Variable
    ld hl,a6
Delete_Variable:
    rst 20h
    rst 10h                         ;call _findsym
    jr c,NotOnCalc
    call _delvar
NotOnCalc:
    ret

Create_Variable:
    rst 20h
    rst 10h
    jr c,NewVariable
    call _delvar
NewVariable:
    call _createreal
    ex de,hl
    ld a,b
    call _set_abs_dest_addr
    ld hl,_OP3
    xor a
    call _set_abs_src_addr
    jr Loop_Variable

Recall_Variable:
    rst 20h                         ;ld (op1) with (hl)
    rst 10h                         ;call _findsym
    ex de,hl
    ld a,b
    call _set_abs_src_addr
    ld hl,_OP1
    xor a
    call _set_abs_dest_addr
Loop_Variable:
    ld hl,10
    xor a
    call _set_mm_num_bytes
    call _mm_ldir
    ret

Text1:
    call _puts                      ;prints string
    call DispAnswer                 ;goes to DispAnswer
    call _newline
    ret

Text2:
    call _clrScrn
    call _homeup                    ;loads hl with (0,0)
    ld hl,String2                   ;loads hl with string
    call _puts                      ;prints in small text
    call _getkey                    ;waits for a key press
    jp Exit                         ;jump to Start1

DispAnswer:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _puts                      ;prints answer
    call _runindicoff               ;turn off run indicator
    ret

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return to call

CalcOff:
    ld a,1
    out (3),a
    halt
    ld a,11
    out (3),a        
    res onInterrupt,(iy+onflags)
    ret

Exit:
    call Check_Variable
    call _clrScrn                   ;clears the screen
    call _homeup                    ;moves cursor to upper left
    call _dispDone                  ;makes it appear like more of a clean exit :-)
    call _jforcecmdnochar           ;normal 'ret' comes up with an error, had to use this

#include "Menu86.asm"

String0:    .db "Linear Calculator 2",0
String1:    .db "Hectosoft, Inc.      ",0
String2:    .db "The program ROOT2sp  is not on your calc!",0
String3:    .db "x+",0
String4:    .db "again",0
String5:    .db "shwor",0
String6:    .db "exit",0
String7:    .db "Distance=",16,"(",190,"x",18,"+",190,"y",18,")  ",0
String8:    .db "x1-x2=",0
String9:    .db "y1-y2=",0
String10:   .db 190,"=",16,"(",0
String11:   .db 16,0
String12:   .db "+",0
String13:   .db 190,"=",0
String14:   .db "next",0
String15:   .db "stop",0
String16:   .db "Mid Points=",203,",",204,0
String17:   .db 203,"=(x1+x2)/2",0
String18:   .db 204,"=(y1+y2)/2",0
String19:   .db "x1+x2= ",0
String20:   .db "y1+y2= ",0
String21:   .db 203,"=",0
String22:   .db 204,"=",0
String23:   .db "Eqn=mx+b",0
String24:   .db "m=(",190,"y/",190,"x)",0
String25:   .db "m=",0
String26:   .db "/",0
String27:   .db "y=mx+b y-mx=b",0
String28:   .db "b=",0
String29:   .db "-",0
String30:   .db "*",0

E1: .db "x1=",0
E2: .db "y1=",0
E3: .db "x2=",0
E4: .db "y2=",0
E5: .db 208,190,"=",0
E6: .db 208,35,190,"=",0
E7: .db 208,203,"=",0
E8: .db 208,204,"=",0
E9: .db 208,"y=",0

ROOT2sp:    .db 7,"ROOT2sp",0

x1: .db $12
    .db 2,"X1",0
x2: .db $12
    .db 2,"X2",0
y1: .db $12
    .db 2,"Y1",0
y2: .db $12
    .db 2,"Y2",0
a1: .db $12
    .db 1,"A",0
a2: .db $12
    .db 1,"B",0
a3: .db $12
    .db 1,"C",0
a4: .db $12
    .db 1,"D",0
a5: .db $12
    .db 5,"SHELL",0
a6: .db $12
    .db 5,"iFrac",0

.end
END